<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExistingArmingSchedule ArrayType
 * @subpackage Arrays
 */
class ArrayOfExistingArmingSchedule extends AbstractStructArrayBase
{
    /**
     * The ExistingArmingSchedule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\ExistingArmingSchedule[]
     */
    public $ExistingArmingSchedule;
    /**
     * Constructor method for ArrayOfExistingArmingSchedule
     * @uses ArrayOfExistingArmingSchedule::setExistingArmingSchedule()
     * @param \CustomerManagement\StructType\ExistingArmingSchedule[] $existingArmingSchedule
     */
    public function __construct(array $existingArmingSchedule = array())
    {
        $this
            ->setExistingArmingSchedule($existingArmingSchedule);
    }
    /**
     * Get ExistingArmingSchedule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\ExistingArmingSchedule[]|null
     */
    public function getExistingArmingSchedule()
    {
        return isset($this->ExistingArmingSchedule) ? $this->ExistingArmingSchedule : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExistingArmingSchedule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExistingArmingSchedule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExistingArmingScheduleForArrayConstraintsFromSetExistingArmingSchedule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExistingArmingScheduleExistingArmingScheduleItem) {
            // validation for constraint: itemType
            if (!$arrayOfExistingArmingScheduleExistingArmingScheduleItem instanceof \CustomerManagement\StructType\ExistingArmingSchedule) {
                $invalidValues[] = is_object($arrayOfExistingArmingScheduleExistingArmingScheduleItem) ? get_class($arrayOfExistingArmingScheduleExistingArmingScheduleItem) : sprintf('%s(%s)', gettype($arrayOfExistingArmingScheduleExistingArmingScheduleItem), var_export($arrayOfExistingArmingScheduleExistingArmingScheduleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExistingArmingSchedule property can only contain items of type \CustomerManagement\StructType\ExistingArmingSchedule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExistingArmingSchedule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\ExistingArmingSchedule[] $existingArmingSchedule
     * @return \CustomerManagement\ArrayType\ArrayOfExistingArmingSchedule
     */
    public function setExistingArmingSchedule(array $existingArmingSchedule = array())
    {
        // validation for constraint: array
        if ('' !== ($existingArmingScheduleArrayErrorMessage = self::validateExistingArmingScheduleForArrayConstraintsFromSetExistingArmingSchedule($existingArmingSchedule))) {
            throw new \InvalidArgumentException($existingArmingScheduleArrayErrorMessage, __LINE__);
        }
        if (is_null($existingArmingSchedule) || (is_array($existingArmingSchedule) && empty($existingArmingSchedule))) {
            unset($this->ExistingArmingSchedule);
        } else {
            $this->ExistingArmingSchedule = $existingArmingSchedule;
        }
        return $this;
    }
    /**
     * Add item to ExistingArmingSchedule value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\ExistingArmingSchedule $item
     * @return \CustomerManagement\ArrayType\ArrayOfExistingArmingSchedule
     */
    public function addToExistingArmingSchedule(\CustomerManagement\StructType\ExistingArmingSchedule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\ExistingArmingSchedule) {
            throw new \InvalidArgumentException(sprintf('The ExistingArmingSchedule property can only contain items of type \CustomerManagement\StructType\ExistingArmingSchedule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExistingArmingSchedule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\ExistingArmingSchedule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\ExistingArmingSchedule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\ExistingArmingSchedule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\ExistingArmingSchedule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\ExistingArmingSchedule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExistingArmingSchedule
     */
    public function getAttributeName()
    {
        return 'ExistingArmingSchedule';
    }
}
